/*
 *	BIRD -- Layer3 VPN Protocol Configuration
 *
 *	(c) 2011 Yandex, LLC
 *      Author: Alexander V. Chernikov <melifaro@yandex-team.ru>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

CF_HDR

#include "proto/l3vpn/l3vpn.h"

CF_DEFINES

#define L3VPN_CFG ((struct l3vpn_config *) this_proto)

CF_DECLS

CF_KEYWORDS(L3VPN, VPN, MPLS, TABLE, RD)

CF_GRAMMAR

CF_ADDTO(proto, l3vpn_proto '}')

l3vpn_proto_start: proto_start L3VPN {
     this_proto = proto_config_new(&proto_l3vpn, sizeof(struct l3vpn_config), $1);
     this_proto->preference = DEF_PREF_PIPE;
  }
 ;

l3vpn_proto:
   l3vpn_proto_start proto_name '{'
 | l3vpn_proto proto_item ';'
 | l3vpn_proto l3vpn_proto_item ';'
 ;

l3vpn_proto_item:
 VPN TABLE SYM {
     if ($3->class != SYM_TABLE)
       cf_error("Routing table name expected");
     L3VPN_CFG->vpn_table = $3->def;
   }
 | MPLS TABLE SYM {
     if ($3->class != SYM_TABLE)
       cf_error("Routing table name expected");
     L3VPN_CFG->mpls_table = $3->def;
   }
 | RD NUM ':' NUM {
   /* type 0 and type 2 */
    if ($2 > 65535)
      L3VPN_CFG->rd = ((u64)2 << 48) + ((u64)$2 << 16) + (u64)$4;
    else
      L3VPN_CFG->rd = ((u64)$2 << 32) + (u64)$4;
 }
 | RD IPA ':' NUM {
   L3VPN_CFG->rd = ((u64)1 << 48) + ((u64)$2 << 16) + (u64)$4;
 }
 ;

CF_CODE

CF_END
